<?php defined('_JEXEC') or die('Restricted access');

/**
 * @version 2.0 $Id: controller.php,v 1.27 2010-09-26 21:31:27 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */ 

jimport('joomla.application.component.controller');

class LinkDirectory2Controller extends JController {

	const URL_WEBLINKS = 'index.php?option=com_linkdirectory2&task=weblinks';
	const URL_WEBCATEGORIES = 'index.php?option=com_linkdirectory2&task=webcategories';
	const URL_WEBCOMMENTS = 'index.php?option=com_linkdirectory2&task=webcomments';
	const URL_PANEL = 'index.php?option=com_linkdirectory2';
	const URL_WEBLINK_EDIT = 'index.php?option=com_linkdirectory2&task=editWebLink&view=weblink';
	const URL_WEBCATEGORY_EDIT = 'index.php?option=com_linkdirectory2&task=editWebCategory&view=webcategory';
	
	/* Task-Namen */
	const TASK_WEBLINKS = 'weblinks';
	const TASK_WEBCATEGORIES = 'webcategories';
	const TASK_WEBCOMMENTS = 'webcomments';
	
	/* Modellnamen */
	const MODEL_WEBCATEGORIES = 'webcategories';
	const MODEL_WEBCATEGORY = 'webcategory';
	const MODEL_WEBLINKS = 'weblinks';
	const MODEL_WEBLINK = 'weblink';
	const MODEL_WEBCOMMENT = 'webcomment';
	const MODEL_WEBCOMMENTS = 'webcomments';

	// ========================================================================
	// =                                                                      =
	// =       Panel                                                          =
	// =                                                                      =
	// ========================================================================
	
	/**
	 * 
	 */
	public function display(){
		JRequest::setVar('view','panel');
		parent::display();	
	}
	
	
	// ========================================================================
	// =                                                                      =
	// =       Configuration                                                  =
	// =                                                                      =
	// ========================================================================
	
	/**
	 */
	public function config() {
		JRequest::setVar('view','config');
		parent::display();
	}
	
	public function about() {
		JRequest::setVar('view','about');
		parent::display();
	}
	
	
	/**
	 * 
	 */
	public function saveConfig(){
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'models'.DS.'config.php';
		//$configuration = new LinkDirectory2ModelConfig();
		$model = $this->getModel('config');
		$saveResult = $model->save();
		if (!$saveResult){
			$msg = JText::_('LD SETTING NOT SAVE');
		} else {
			$msg = JText::_('LD SETTING SAVED');
		}
		$this->setRedirect(self::URL_PANEL, $msg);
	}

	/**
	 * 
	 */
	public function cancelConfig(){
		$this->setRedirect(self::URL_PANEL);
	}
	
	
	// ========================================================================
	// =                                                                      =
	// =       Link/Links                                                     =
	// =                                                                      =
	// ========================================================================

	/**
	 * 
	 */
	public function weblinks() {
		JRequest::setVar('view','weblinks');
		parent::display();
	}
	
	/**
	 * 
	 */
	public function publishWebLink() {
		JRequest::checkToken() or jexit( 'Invalid Token' );
		switch ($this->getTask()){
			case 'publishWebLink':
				$publish = 1; break;
			case 'unpublishWebLink':
			default:
				$publish = 0; break;
		}
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		if (count( $cid ) < 1) {
			if ($publish == 1) {
				JError::raiseWarning(200, JText::_('SELECT AN ITEM TO PUBLISH'));
			}
			else {
				JError::raiseWarning(200, JText::_('SELECT AN ITEM TO UNPUBLISH'));
			}
			$this->setRedirect( self::URL_WEBLINKS);
			return;
		}
		$model = $this->getModel(self::MODEL_WEBLINK);
		$publishResult = $model->publish($cid, $publish);
		if(!$publishResult) {
			$message = JText::sprintf('ERROR OCCURRED', $model->getError());
			$this->setRedirect( self::URL_WEBLINKS, $message );
			return;
		} 
		$message = $publish ? JText::_('SUCCESS N ITEMS PUBLISHED') : JText::_('SUSCESS N ITEMS UNPUBLISHED');
		$this->setRedirect( self::URL_WEBLINKS, $message );
		return;	
	}
	
	/**
	 * 
	 */
	public function editWebLink(){
		$mainframe = JFactory::getApplication();
		JRequest::setVar( 'hidemainmenu', 1 );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar( 'view'  , 'weblink');
		JRequest::setVar( 'edit', true );
		$model = $this->getModel('weblink');
		$checkoutResult = $model->isCheckedOut();
		if ($checkoutResult){
			JError::raiseNotice(200, JText::_('WEBLINK IS CHECKOUT FROM AN ANOTHER USER'));
			$mainframe->redirect($this->mapSourceToRedirectUrl(self::TASK_WEBLINKS));
		}
		$result = $model->checkout();
		parent::display();
	}
	
	/**
	 * 
	 */
	public function addWebLink(){
		JRequest::setVar( 'hidemainmenu', 1 );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar( 'view'  , 'weblink');
		JRequest::setVar( 'edit', false );
		$model = $this->getModel(self::MODEL_WEBLINK);
		parent::display();
	}

	/**
	 * 
	 */
	public function prepareImportWebLinks(){
		JRequest::setVar( 'hidemainmenu', 0 );
		JRequest::setVar( 'view'  , 'import');
		JRequest::setVar( 'prepare'  , true );
		$model = $this->getModel(self::MODEL_WEBLINKS);

		parent::display();
	}
	
	
	public function importWebLinks(){
		JRequest::setVar( 'hidemainmenu', 0 );
		JRequest::setVar( 'view'  , 'import');
		JRequest::setVar( 'prepare'  , false );
		$model = $this->getModel(self::MODEL_WEBLINKS);
		parent::display();
	}
	
	/**
	 * 
	 */
	public function saveWebLink() {
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$post	= JRequest::get('post');
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$post['id'] = (int) $cid[0];
		$post['description_long'] = JRequest::getString('description_long','','post',JREQUEST_ALLOWHTML);	
		$model = $this->getModel(self::MODEL_WEBLINK);
		$storeResult = $model->store($post);
		if ($storeResult) {
			$msg = JText::_('WEBLINK SAVED');
		} else {
			$msg = JText::_('ERROR SAVING WEBLINK');
		}
		switch ($this->getTask()){
			case 'applyWebLink':
				if ((int)$cid[0] > 0) { // Link ist neu -> kein apply, weiter bei default
					$sourceForURL = $this->getSourceFromRequestForURL();			
					$this->setRedirect(self::URL_WEBLINK_EDIT.$sourceForURL . '&cid[]='.(int)$cid[0]);
					return;
				}
			default:
				$this->checkin($model);
				$this->setRedirect($this->mapSourceToRedirectUrl(self::TASK_WEBLINKS), $msg);
		}
	}

	/**
	 * 
	 */
	public function removeWebLink() {
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		if (count( $cid ) < 1) {
			JError::raiseNotice(200, JText::_('PLEASE MAKE A SELECTION FROM THE LINK LIST TO'));
		} else {
			$model = $this->getModel(self::MODEL_WEBLINK);
			$deleteResult = $model->delete($cid);
			if(!$deleteResult) {
				JError::raiseWarning(500,JText::_('CAN NOT REMOVE THE LINKS'),$model->getError(true));
			}
		}
		$this->setRedirect(self::URL_WEBLINKS );
	}
	
	/**
	 * 
	 */
	public function cancelWebLink(){
		$model = $this->getModel(self::MODEL_WEBLINK);
		$this->checkin($model);
		$this->setRedirect($this->mapSourceToRedirectUrl(self::TASK_WEBLINKS));	
	}
	
	/**
	 * 
	 */
	public function displayWeblinksForOneCategory(){
		global $option;
		$mainframe = JFactory::getApplication();
		$catid = JRequest::getInt('catid',0);
		$filter_catid = $mainframe->setUserState( $option.'links'.'filter_catid',	$catid);
		$this->weblinks();
	}
	
	/**
	 * 
	 */
	public function orderDownWebLinks() {
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$model = $this->getModel(self::MODEL_WEBLINK);	
		switch ($this->getTask()){
			case 'orderUpWebLinks':
				$direction = -1; break;
			case 'orderDownWebLinks':
			default:
				$direction = 1; break;
		}
		$moveResult = $model->move($direction);
		if ($moveResult){
			$message = null;
		} else {
			JText::sprintf('CAN NOT MOVE LINK', $model->getError());	
		}
		$this->setRedirect(self::URL_WEBLINKS,$message);
	}
	
	/**
	 * 
	 */
	public function saveOrderWebLinks() {
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);
		$model = $this->getModel(self::MODEL_WEBLINK);
		$resultSaveOrder = $model->saveorder($cid, $order);
		if ($result){
			$messageSaveOrder = JText::_('NEW ORDERING SAVED');	
 		} else {
 			$message = JText::sprintf('CAN NOT SAVE ORDER', $model->getError());
 		}
		$this->setRedirect(self::URL_WEBLINKS, $message );
	}	
	
	// ========================================================================
	// =                                                                      =
	// =       Category/Categories                                            =
	// =                                                                      =
	// ========================================================================
	
	/**
	 * 
	 */
	public function cancelWebCategory(){
		$model = $this->getModel(self::MODEL_WEBCATEGORY);
		$this->checkin($model);
		$this->setRedirect($this->mapSourceToRedirectUrl(self::TASK_WEBCATEGORIES));
	}
	
	/**
	 * 
	 */
	public function switchToCategoryTree(){
		$model = $this->getModel(self::MODEL_WEBCATEGORIES);
		$model->setTreeModel(true);
		$this->webcategories();
	}
	
	/**
	 * 
	 */
	public function switchToCategoryList(){
		$model = $this->getModel(self::MODEL_WEBCATEGORIES);
		$model->setTreeModel(false);
		$this->webcategories();
	}
	
	/**
	 * 
	 */
	public function webcategories() {
		JRequest::setVar('view','webcategories');
		parent::display();
	}
		
	/**
	 * 
	 */
	public function publishWebCategory() {
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		switch ($this->getTask()){
			case 'publishWebCategory':
				$publish = 1; break;
			case 'unpublishWebCategory':
			default:
				$publish = 0; break;
		}
		if (count( $cid ) < 1) {
			if ($publish == 1) {
				JError::raiseWarning(200, JText::_('SELECT AN ITEM TO PUBLISH'));
			}
			else {
				JError::raiseWarning(200, JText::_('SELECT AN ITEM TO UNPUBLISH'));
			}
			$this->setRedirect( self::URL_WEBCATEGORIES);
			return;
		} 
		$model = $this->getModel(self::MODEL_WEBCATEGORY);
		$publishResult = $model->publish($cid, $publish); 		
		if(!$publishResult) {
			$message = JText::sprintf('ERROR OCCURRED', $model->getError());
			$this->setRedirect( self::URL_WEBCATEGORIES, $message );
			return;
		} 
		$message = $publish ? JText::_('SUCCESS N ITEMS PUBLISHED') : JText::_('SUSCESS N ITEMS UNPUBLISHED');
		$this->displayNoticeForNoChangePublishStatus($model);
		$this->setRedirect( self::URL_WEBCATEGORIES, $message);
	}
		
	/**
	 * 
	 */
	public function editWebCategory(){
		$mainframe = JFactory::getApplication();
		JRequest::setVar( 'hidemainmenu', 1 );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar( 'view'  , 'webcategory');
		JRequest::setVar( 'edit', true );
		$model = $this->getModel(self::MODEL_WEBCATEGORY);
		
		if ($model->isCheckedOut()){
			JError::raiseNotice(200, JText::_('WEBCATEGORY IS CHECKOUT FROM AN ANOTHER USER'));
			$mainframe->redirect($this->mapSourceToRedirectUrl(self::TASK_WEBCATEGORIES));
		}
		$result=$model->checkout();
		if ($result == false){
			JError::raiseNotice(200, JText::_('CAN NOT CHECKOUT WEBCATEGORY'));
			$mainframe->redirect($this->mapSourceToRedirectUrl(self::TASK_WEBCATEGORIES));
		}
		parent::display();
	}
	
	/**
	 * 
	 */
	public function addWebCategory(){
		JRequest::setVar( 'hidemainmenu', 1 );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar( 'view'  , 'webcategory');
		JRequest::setVar( 'edit', false );
		$model = $this->getModel(self::MODEL_WEBCATEGORY);
		parent::display();
	}
	
	/**
	 * 
	 */
	public function saveWebCategory() {
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$post	= JRequest::get('post');
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$post['id'] = (int) $cid[0];
		$post['description'] = JRequest::getString('description','','post',JREQUEST_ALLOWHTML);	
		$model = $this->getModel(self::MODEL_WEBCATEGORY);
		$storeResult = $model->store($post);
		if ($storeResult) {
			$msg = JText::_('WEBCATEGORY SAVED');
		} else {
			$msg = JText::_('ERROR SAVING WEBCATEGORY');
		}
		$this->checkin($model);
		switch ($this->getTask()){
			case 'applyWebCategory':
				if ((int)$cid[0] > 0) { // Kategorie ist neu -> kein apply, weiter bei default
					$sourceForURL = $this->getSourceFromRequestForURL();			
					$this->setRedirect(self::URL_WEBCATEGORY_EDIT.$sourceForURL . '&cid[]='.(int)$cid[0]);
					return;
				}
			default:
				$this->setRedirect($this->mapSourceToRedirectUrl(self::TASK_WEBCATEGORIES), $msg);
		}
	}
		
	/**
	 * 
	 */
	public function removeWebCategory() {
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		if (count( $cid ) < 1) {
			JError::raiseNotice(200, JText::_( 'SELECT AN ITEM TO DELETE' ) );
		}
		$model = $this->getModel(self::MODEL_WEBCATEGORY);
		$deleteResult = $model->delete($cid); 
		if(!$deleteResult) {
			JError::raiseWarning(500,JText::_('CAN NOT DELETE ITEM'),$model->getError(true));
		} else {
			$this->displayModelWarning($model);
		}
		$this->setRedirect(self::URL_WEBCATEGORIES );
	}
	
	/**
	 * 
	 */
	public function orderDownWebCategories() {
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$model = $this->getModel(self::MODEL_WEBCATEGORY);	
		switch ($this->getTask()){
			case 'orderUpWebCategories':
				$direction = -1; break;
			case 'orderDownWebCategories':
			default:
				$direction = 1; break;
		}
		$result = $model->move($direction);
		if ($result){
			$message = null;
		} else {
			JText::sprintf('CAN NOT MOVE CATEGORY', $model->getError());	
		}
		$this->setRedirect(self::URL_WEBCATEGORIES,$message);
	}
	
	/**
	 * 
	 */
	public function saveOrderWebCategories(){
		JRequest::checkToken() or jexit( 'Invalid Token' );		
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		$order 	= JRequest::getVar('order', array(0), 'post', 'array' );
		JArrayHelper::toInteger($order);
		if (count( $cid ) < 1) {
			JError::raiseNotice(200, JText::_( 'SELECT AN ITEM TO SAVE ORDER' ) );
		}
		$model = $this->getModel(self::MODEL_WEBCATEGORY);
		$resultSaveOrder = $model->saveorder($cid,$order);
		if ($resultSaveOrder){
			$message = JText::_('NEW ORDERING SAVED');	
 		} else {
 			$message = JText::sprintf('CAN NOT SAVE ORDER', $model->getError());
 		}
		$this->setRedirect(self::URL_WEBCATEGORIES,$message);
	}
	
	/**
	 * Gibt die Liste aller Error des Modell als 'Notice' aus
	 * @param JModel $model JModel, welches Errors zur Ausgabe als Notice enthält 
	 */
	public function displayModelWarning($model){
		if ($model->getErrors()){
			foreach ($model->getErrors() as $error){
				if (!empty($error)){
					JError::raiseNotice(1,$error);
				}
			}
		}
	}
	
	// ========================================================================
	// =                                                                      =
	// =       Comments                                                       =
	// =                                                                      =
	// ========================================================================
	
	/**
	 * 
	 */
	public function comments() {
		JRequest::setVar('view','webcomments');
		parent::display();
	}
	
	
	/**
	 * 
	 */
	public function  webcomments(){
		self::comments();
	}
	
	/**
	 * 
	 */
	public function editWebComment(){
		JRequest::setVar( 'hidemainmenu', 1 );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar( 'view'  , 'webcomment');
		JRequest::setVar( 'edit', true );
		$model = $this->getModel('webcomment');
		$model->checkout();
		parent::display();
	}
	
	/**
	 * 
	 */
	public function addWebComment(){
		JRequest::setVar( 'hidemainmenu', 1 );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar( 'view'  , 'webcomment');
		JRequest::setVar( 'edit', false );
		$model = $this->getModel(self::MODEL_WEBCOMMENT);
		parent::display();
	}
	
	/**
	 * 
	 */
	public function cancelWebComment(){
		$model = $this->getModel(self::MODEL_WEBCOMMENT);
		$this->checkin($model);
		$this->setRedirect($this->mapSourceToRedirectUrl(self::TASK_WEBCOMMENTS));
	}
	
	/**
	 * 
	 */
	public function saveWebComment() {
		JRequest::checkToken() or jexit('Invalid Token');
		$post	= JRequest::get('post');
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$post['rev_id'] = (int) $cid[0];	
		$model = $this->getModel(self::MODEL_WEBCOMMENT);
		$storeResult = $model->store($post);
		if ($storeResult) {
			$msg = JText::_( 'WEBCOMMENT SAVED' );
		} else {
			$msg = null;
			$this->displayModelErrorAsNotice($model,JText::_( 'ERROR SAVING WEBCOMMENT' ));
		}
		$this->checkin($model);
		$this->setRedirect(self::URL_WEBCOMMENTS, $msg);
	}

	/**
	 * 
	 */
	public function removeWebComment() {
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		if (count( $cid ) < 1) {
			JError::raiseNotice(200, JText::_('PLEASE MAKE A SELECTION FROM THE COMMENT LIST TO'));
		} else {
			$model = $this->getModel(self::MODEL_WEBCOMMENT);
			$deleteResult = $model->delete($cid); 
			if(!$deleteResult) {
				JError::raiseError(500,JText::_('CAN NOT REMOVE THE COMMENTS'),$model->getError(true));
			}
		}
		$this->setRedirect(self::URL_WEBCOMMENTS );
	}
	
	
		/**
	 * 
	 */
	public function publishWebComment() {
		JRequest::checkToken() or jexit( 'Invalid Token' );
		switch ($this->getTask()){
			case 'publishWebComment':
				$publish = 1; break;
			case 'unpublishWebComment':
			default:
				$publish = 0; break;
		}
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		if (count( $cid ) < 1) {
			if ($publish == 1) {
				JError::raiseWarning(200, JText::_('SELECT AN ITEM TO PUBLISH'));
			}
			else {
				JError::raiseWarning(200, JText::_('SELECT AN ITEM TO UNPUBLISH'));
			}
			$this->setRedirect( self::URL_WEBLINKS);
			return;
		}
		$model = $this->getModel(self::MODEL_WEBCOMMENT);
		$publishResult = $model->approved($cid, $publish);
		if(!$publishResult) {
			$message = JText::sprintf('ERROR OCCURRED', $model->getError());
			$this->setRedirect( self::URL_WEBCOMMENTS, $message );
			return;
		} 
		$message = $publish ? JText::_('SUCCESS N ITEMS PUBLISHED') : JText::_('SUSCESS N ITEMS UNPUBLISHED');
		$this->setRedirect( self::URL_WEBCOMMENTS, $message );
		return;	
	}
	
	
	// ========================================================================
	// =                                                                      =
	// =       Install                                                        =
	// =                                                                      =
	// ========================================================================
			
	/**
	 * 
	 */
	public function installjCommentPlugin(){
		require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'classes'.DS.'JCommentInstallHelper.php';
		$jommentInstallHelper = new JCommentInstallHelper();
		$result = $jommentInstallHelper->installLinkdirectory2Plugin();
		if ($result === true){
			$msg = JText::_('Copy from jComment-plugin was successfully');
		} else {
			$msg->$result;
		}
		$this->setRedirect(self::URL_PANEL, $msg);
		return;
	}
	
	
	// ========================================================================
	// =                                                                      =
	// =       Utils                                                          =
	// =                                                                      =
	// ========================================================================

	/**
	 * 
	 */
	private function mapSourceToRedirectUrl($default){
		$source = JRequest::getString('source','');
		if ($source == '' ) {
			$source = $default;	
		}
		switch ($source) {
			case self::TASK_WEBLINKS:
				return self::URL_WEBLINKS;
			case self::TASK_WEBCOMMENTS:
				return self::URL_WEBCOMMENTS;
			case self::TASK_WEBCATEGORIES:
				return self::URL_WEBCATEGORIES;
			default:
				return self::URL_PANEL;					
		}
	}
	
	private function getSourceFromRequestForURL(){
		$source = JRequest::getString('source','');	
		switch ($source) {
			case self::TASK_WEBLINKS:
			case self::TASK_WEBCOMMENTS:
			case self::TASK_WEBCATEGORIES:
				return '&source='.$source;
			default:
				return '';					
		}
	}
	
	
	private function checkin($model){
		$checkinResult = $model->checkin();
		if (!$checkinResult){
			JError::raiseWarning(500,JText::_('CAN NOT CHECKIN ITEM'));
		}
	}
	
	/**
	 * 
	 */
	private function displayNoticeForNoChangePublishStatus($model){
		if ($model->getErrors()){
			foreach ($model->getErrors() as $error){
				JError::raiseNotice(1,JText::sprintf('Can not change publish for category', $error));
			}
		}
	}
	
	/**
	 * 
	 */
	private function displayModelErrorAsNotice($model,$message=''){	
			JError::raiseWarning(500,$message . ': ' . $model->getError());
	}
	
	
}

?>
