<?php defined('_JEXEC') or die( 'Restricted access' );

/**
 * @version 2.0 $Id: information.php,v 1.10 2011-03-25 22:34:45 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

jimport('joomla.application.component.model');

class LinkDirectory2ModelInformation extends JModel{
	
	const URL_FOR_NEWEST_LINK_DIRECROY_VERSION_INFO = 'http://www.joomla-hklein.de/linkdirectory2.php';
	
	private $_totalLinks = 0;
	private $_totalPublishedLinks = 0;
	private $_totalApprovedLinks = 0;
	private $_totalCategories = 0;
	private $_totalPublishedCategories  = 0;
	private $_totalApprovedCategories = 0;
	private $_totalComments = 0;
	private $_totalPublishedComments = 0;
	private $_totalApprovedComments = 0;
	
	public function __construct(){
		parent::__construct();
	}
	
	public function getTotalLinks(){
		if (!$this->_totalLinks) {
			$query='select count(*) from #__ldlinks';
			$this->_db->setQuery($query);
			$this->_totalLinks=$this->_db->loadResult(); 
		}
		return $this->_totalLinks;
	}
	
	/**
	 * Anzahl veröffentlichter Links inv veröffentlichen Kategorien.
	 *
	 * @return Anzahl veröffentlichter Links
	 */
	public function getTotalPublishedLinks(){
		if (!$this->_totalPublishedLinks) {
			$query='select count(*) from #__ldlinks l  '
			. ' LEFT JOIN #__ldcats AS c ON c.id = l.catid' 
			. ' WHERE l.published = 1 '
			. ' AND c.published = 1 '
			;
			$this->_db->setQuery($query);
			$this->_totalPublishedLinks=$this->_db->loadResult(); 
		}
		return $this->_totalPublishedLinks;
	}
	
	public function getTotalApprovedLinks(){
	if (!$this->_totalApprovedLinks) {
			$query='select count(*) from #__ldlinks l  '
			. ' LEFT JOIN #__ldcats AS c ON c.id = l.catid' 
			. ' WHERE l.published = 0 '
			. ' AND c.published = 1 '
			;
			$this->_db->setQuery($query);
			$this->_totalApprovedLinks=$this->_db->loadResult(); 
		}
		return $this->_totalApprovedLinks;
	}
	
	
	public function getTotalCategories(){
		if (!$this->_totalCategories) {
			$query='select count(*) from #__ldcats';
			$this->_db->setQuery($query);
			$this->_totalCategories=$this->_db->loadResult(); 
		}
		return $this->_totalCategories;
	}
	
	public function getTotalPublishedCategories(){
		if (!$this->_totalPublishedCategories) {
			$query='select count(*) from #__ldcats c  ' 
			. ' WHERE c.published = 1 '
			;
			$this->_db->setQuery($query);
			$this->_totalPublishedCategories=$this->_db->loadResult(); 
		}
		return $this->_totalPublishedCategories;
	}
	
	
	public function getTotalComments(){
		if (!$this->_totalPublishedComments) {
			$query='select count(*) from #__ldcomment c  ' 
			;
			$this->_db->setQuery($query);
			$this->_totalPublishedComments=$this->_db->loadResult(); 
		}
		return $this->_totalPublishedComments;
	}
	
	public function getTotalPublishedComments(){
		if (!$this->_totalPublishedComments) {
			$query='select count(*) from #__ldcomment c  ' 
			. ' WHERE c.published = 1 '
			;
			$this->_db->setQuery($query);
			$this->_totalPublishedComments=$this->_db->loadResult(); 
		}
		return $this->_totalPublishedComments;
	}
	
	public function getTotalApprovedComments(){
		if (!$this->_totalApprovedCategories) {
			$query='select count(*) from #__ldcomment c  ' 
			. ' WHERE c.published = 1 '
			;
			$this->_db->setQuery($query);
			$this->_totalApprovedCategories=$this->_db->loadResult(); 
		}
		return $this->_totalApprovedCategories;
	}

	/** Ermittelt die Version der installierten Komponente aus linkdirectory2.xml
	 * 
	 * @return Installierte Version von Link Directory 2
	 */
	public function getCommponetVersion(){
		$modInstallFile = JPATH_COMPONENT_ADMINISTRATOR.'/linkdirectory2.xml';
		$installFile = JApplicationHelper::parseXMLInstallFile($modInstallFile);
		return $installFile['version'];
	}
	
	public function getModulVersion($modulName){
		$modInstallFile = JPATH_SITE.DS.'modules'.DS.$modulName.DS.$modulName.'.xml';
		$installFile = JApplicationHelper::parseXMLInstallFile($modInstallFile);
		return $installFile['version'];
	}
	
	/**
	 * Ermittelt die Version eines Plugins.
	 * @param String type Unterverzeichnis, in dem sich das Plugin befindet. Beispiel: 'search'
	 * @param String pluginName Name des Plugins 
	 */
	public function getPluginVersion($type,$pluginName){
		$pluginInstallFile = JPATH_SITE.DS.'plugins'.DS.$type.DS.$pluginName.'.xml';
		$installFile = JApplicationHelper::parseXMLInstallFile($pluginInstallFile);
		return $installFile['version'];
	}
	
	/* Ermittelt die aktuellen Link Directory 2 Version. 
	 * 
	 */
	public function getLatestCommponetVersion($checkversion = true){
		$handle=NULL;
		if ($checkversion) {
			$filename = self::URL_FOR_NEWEST_LINK_DIRECROY_VERSION_INFO;
			$handle = @fopen($filename, "r");
		}
		if (!$handle) {
			$currentver = JText::_('LD_NEWEST_VERSION_IS_UNKNOWN');
		} else {
			$currentver = fread($handle, 10);
			fclose($handle);
		}
		if (! $currentver) {
			$currentver = JText::_('LD_CAN_NOT_CALC_VERSION_INFO');
		}
		return $currentver;
	}
	
	public function getWeblinkCount(){
			$query='select count(*) from #__weblinks c  ' 
			;
			$this->_db->setQuery($query);
			return $this->_db->loadResult(); 
	}
	
	public function getCategoryCount(){
			$query='select count(*) from #__categories c  ' 
			. ' where section = \'com_weblinks\''
			;
			$this->_db->setQuery($query);
			return $this->_db->loadResult(); 
	}
	
	
}
