<?php  defined('_JEXEC') or die( 'Restricted access' );

/**
 * @version 2.0 $Id: CategoryHtmlHelper.php,v 1.1 2010-01-31 17:48:05 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

class CategoryHtmlHelper{

	/**
	 * Liefert alle veröffentlichten Webkategorien als HTML-"Select Box" inkl. Root-Kategorie und '- Auswahl Kategorie -' 
	 * @param String $elementName "HTML"-Name der "Select Box"
	 * @param int $selectedWebcategory  Id der Webkategorie, die ausgewählt werden soll
	 * @param String $javascript Javascript, um das die "Select Box" erweitert werden soll 
	 * @param String $order Spalte, die zum Sortieren der Webkategorien herangezogen werden soll
	 * @param int $height Höhe der "Select Box" in Zeilen
	 * @return String mit HTML für Select-Box 
	 */
	public function getCategoryListAsHtml($elementName, $selectedWebcategory = NULL, $javascript = NULL, $order = 'ordering', $height = 1 ) {
		$list = CategoryHtmlHelper::getCategoryHierarchyAsArray();
		$options[] = JHTML::_('select.option', '' , JText::_('SELECT CATEGORY'),'value','text'); 
		$options[] = JHTML::_('select.option', 0 , JText::_('ROOT CATEGORY'),'value','text');
		foreach ($list as $item) {
			$options[] = JHTML::_('select.option', $item->id, $item->treename,'value','text');
		}
		$category =  JHTML::_('select.genericlist',  $options, $elementName, 'class="inputbox" size="'. $height .'" '. $javascript, 'value', 'text', $selectedWebcategory );
		return $category;
	}

	private function getCategoryHierarchyAsArray() {
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();

		$query = 'SELECT c.id, c.name, c.parent_id AS parent FROM #__ldcats c '
		. ' WHERE published <> -2 ' // TODO access wieder auswerten: AND access <= '$user->gid'"
		. ' ORDER BY ordering ' ;

		$db->setQuery($query);
		$items = $db->loadObjectList();
		$children = array();

		foreach ($items as $v) {
			$pt = $v->parent;
			$list = @$children[$pt] ? $children[$pt] : array();
			array_push($list, $v);
			$children[$pt] = $list;
		}
		$array = JHTML::_('menu.treerecurse', 0, '', array(), $children, 9999, 0, 0);
		return $array;
	}
}
?>