<?php

/**
 * @version 2.0 $Id: router.php,v 1.3 2010-05-06 22:29:25 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

function Linkdirectory2BuildRoute(&$query) {
	$segments = array();

	if(isset($query['view'])) {
		$segments[] = $query['view'];
		unset($query['view']);
	};
	
	if(isset($query['task'])) {
		$segments[] = $query['task'];
		unset($query['task']);
	};
	
	if(isset($query['id'])) {
		$segments[] = $query['id'];
		unset($query['id']);
	};
	
	if(isset($query['source'])) {
		$segments[] = $query['source'];
		unset($query['source']);
	};
	
	if(isset($query['sid'])) {
		$segments[] = $query['sid'];
		unset($query['sid']);
	};
	
	if(isset($query['catid'])) {
		$segments[] = $query['catid'];
		unset($query['catid']);
	};	
	
	if(isset($query['searchtext'])) {
		$segments[] = $query['searchtext'];
		unset($query['searchtext']);
	};
	
	return $segments;
}

function getLinkdirectory2DefaultRoute($segments){
	$mainframe = JFactory::getApplication();
	$mainframe->enqueueMessage('Internal error occured [' . implode(",", $segments).']');
	$vars = array();
	$vars['view'] = 'categories';
	return $vars;
}

function Linkdirectory2ParseRoute($segments) {
	$vars = array();
	$menu =& JSite::getMenu();
	$item =& $menu->getActive();
	$count = count($segments);
	if ($count == 0 ) {
		return getLinkdirectory2DefaultRoute($segments);
	}
	
	switch($segments[0]) {
		case 'cancelWebLink':{
				if ($count < 3) return getLinkdirectory2DefaultRoute($segments);
				$vars['task']  = $segments[0];
				$vars['source']  = $segments[1];
				$vars['sid']  = $segments[2];
				break;		
		}
		case 'link' : {
			$vars['view']  = $segments[0];
			if ($count == 1){ // search auf Detail-Page; restlichen Paramter aus Get-Resust
				break;
			}
			
			if ($count < 1) return getLinkdirectory2DefaultRoute($segments);
			
			if ( ''. (int)$segments[1] === $segments[1] ){
				$vars['id']  = $segments[1];
			} else {
				$vars['task']  = $segments[1];
				switch ($vars['task']){
					case 'add': {
						if ($count < 3) return getLinkdirectory2DefaultRoute($segments);
						$vars['source']  = $segments[2];
						$vars['sid']  = $segments[3];
						if ($count > 4){
							$vars['catid']  = $segments[4];
						}
						break;
					}
					case 'rate':
					case 'comment': 
						if ( $count > 2 && ''. (int)$segments[2] === $segments[2] ){
							$vars['id']  = $segments[2];
						} 
						break;
					default:
						if ($count < 2) return getLinkdirectory2DefaultRoute($segments);
						$vars['id']  = $segments[2];
						break;
				}
			}
			break;
		} 
		case 'categories' : 
			$vars['view']  = $segments[0];
			if ($count == 1 ){
				break;
			}
			if ($count < 1) return getLinkdirectory2DefaultRoute($segments);
			if ( ''. (int)$segments[1] === $segments[1] ){
				$vars['catid']  = $segments[1];
			} else {
				return getLinkdirectory2DefaultRoute($segments);
			}
			break;
		case 'search':
			if ($count < 2) return getLinkdirectory2DefaultRoute($segments);
			$vars['view']  = $segments[0];
			$vars['task']  = $segments[1];
			$vars['catid'] = $segments[2];
			if ($count > 3)
				$vars['searchtext'] = $segments[3];
			break;
	}
	return $vars;
}